/*
 * Copyright (c) 2008 Mellanox Technologies.  All rights reserved.
 *
 * This software is available to you under the OpenIB.org BSD license
 * below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */


#include <precompile.h>

#if defined(EVENT_TRACING)
#ifdef offsetof
#undef offsetof
#endif
#include "ipoib_xfr_mgr.tmh"
#endif


const ipoib_guid2mac_translation_t guid2mac_table[] = {
	{0x00, 0x30, 0x48, 0xE7},	//SuperMicro
	{0x00, 0x05, 0xAD, 0xE7},	//Topspin
	{0x00, 0x18, 0x8B, 0xE7},	//Dell
	{0x00, 0x1A, 0x4B, 0xE7},	//HP
	{0x00, 0x17, 0x08, 0xE7},	//HP
	{0x00, 0x1E, 0x0B, 0xE7},	//HP

	{0x00, 0x03, 0xBA, 0xE7},	//Oracle
	{0x00, 0x05, 0xAD, 0xE7},	//Topspin
	{0x00, 0x0D, 0x9D, 0xE7},	//HP
	{0x00, 0x11, 0x0A, 0xE7},	//HP
	{0x00, 0x11, 0x85, 0xE7},	//HP
	{0x00, 0x12, 0x79, 0xE7},	//HP
	{0x00, 0x13, 0x21, 0xE7},	//HP
	{0x00, 0x14, 0x38, 0xE7},	//HP
	{0x00, 0x16, 0x35, 0xE7},	//HP
	{0x00, 0x17, 0x08, 0xE7},	//HP
	{0x00, 0x17, 0xA4, 0xE7},	//HP
	{0x00, 0x18, 0x8B, 0xE7},	//Dell
	{0x00, 0x18, 0xFE, 0xE7},	//HP
	{0x00, 0x19, 0xBB, 0xE7},	//HP
	{0x00, 0x21, 0x28, 0xE7},
	{0x00, 0x1A, 0x4B, 0xE7},	//HP
	{0x00, 0x1B, 0x78, 0xE7},	//HP
	{0x00, 0x1E, 0x0B, 0xE7},	//HP
	{0x00, 0x22, 0x64, 0xE7},	//HP
	{0x00, 0x23, 0x7D, 0xE7},	//HP
	{0x00, 0x24, 0xE8, 0xE7},
	{0x00, 0x25, 0x90, 0xE7},	//SuperMicro
	{0x00, 0x25, 0xB3, 0xE7},
	{0x00, 0x30, 0x48, 0xE7},	//SuperMicro
	{0x00, 0x80, 0x5F, 0xE7},	//HP
	{0x78, 0xE7, 0xD1, 0xE7},
	{0xD8, 0xD3, 0x85, 0xE7},
	{0xF0, 0x4D, 0xA2, 0xE7}, 

	{0x00, 0x00, 0x00, 0x00},
};

